/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cid;


import cdac.medinfo.sdk.dcm30_04.templates.dicomsnomedmap.EnumChestCardiacSNOMEDMap;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ChestBorderDefinition;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_ChestBorderDefinition;


/**
 * This class represents ChestBorderDefinition - CID6120
 */
public class ChestBorderDefinition_CID6120 
{
	
	/**
	 * The Code Value for template.
	 */
	private String strCodeValue = null;

	/**
	 * The Code Meaning for template.
	 */
	private String strCodeMeaning = null;

	/**
	 * The Coding Scheme Designator for template.
	 */
	private String strCodingSchemeDesignator;
	/**
	 * The SNOMED CT ID for template.
	 */
	private String strSNOMEDCTID = null;
	
	/**
	 * Retrieves the value for SNOMED-CT ID.
	 * @return String value for SNOMED-CT ID.
	 */
	public String getSNOMEDCTID() 
	{
		return strSNOMEDCTID;
	}
	/**
	 * Instantiates a new ChestBorderDefinition_CID6120 Template 
	 */
	public ChestBorderDefinition_CID6120()
	{

	}

	/**
	 * Retrieves the value for Code Meaning.
	 * @return String value for Code Meaning.
	 */
	public String getCodeMeaning()
	{
		return strCodeMeaning;
	}

	/**
	 * Retrieves the value for Code Value.
	 * @return String value for Code Value.
	 */
	public String getCodeValue() 
	{
		return strCodeValue;
	}

	/**
	 * Retrieves the value for Coding Scheme Designator.
	 * @return String value for Coding Scheme Designator.
	 */
	public String getCodingSchemeDesignator() 
	{
		return strCodingSchemeDesignator;
	}

	/**
	 * Sets the Code Value according to Code Meaning.
	 * @param enumChestBorderDefinition Object of EnumCM_ChestBorderDefinition represents Code Meaning.
	 */
	private void setCodeValue(EnumCM_ChestBorderDefinition enumChestBorderDefinition)
	{
		switch(enumChestBorderDefinition)
		{
		case WELL_DEFINED: this.strCodeValue =EnumCV_ChestBorderDefinition.WELL_DEFINED_R_40771.getValue(); break;
		case SHARPLY_DEFINED: this.strCodeValue =EnumCV_ChestBorderDefinition.SHARPLY_DEFINED_112137.getValue(); break;
		case POORLY_DEFINED: this.strCodeValue =EnumCV_ChestBorderDefinition.POORLY_DEFINED_R_428E7.getValue(); break;
		case DISTINCTLY_DEFINED: this.strCodeValue =EnumCV_ChestBorderDefinition.DISTINCTLY_DEFINED_112138.getValue(); break;
		case WELL_DEMARCATED: this.strCodeValue =EnumCV_ChestBorderDefinition.WELL_DEMARCATED_112139.getValue(); break;
		case SHARPLY_DEMARCATED: this.strCodeValue =EnumCV_ChestBorderDefinition.SHARPLY_DEMARCATED_112140.getValue(); break;
		case POORLY_DEMARCATED: this.strCodeValue =EnumCV_ChestBorderDefinition.POORLY_DEMARCATED_112141.getValue(); break;
		case CIRCUMSCRIBED: this.strCodeValue =EnumCV_ChestBorderDefinition.CIRCUMSCRIBED_112142.getValue(); break;
		}
	}
	/**
	 * Sets the SNOMED-CT ID.
	 * @param enumChestBorderDefinition Object of EnumCM_ChestBorderDefinition represents Code Meaning.
	 */
	private void setSNOMEDCTID(EnumCM_ChestBorderDefinition enumChestBorderDefinition)
	{
		switch(enumChestBorderDefinition)
		{
		case WELL_DEFINED : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.WELL_DEFINED.getSNOMEDCTID(); break;
		case POORLY_DEFINED : this.strSNOMEDCTID =EnumChestCardiacSNOMEDMap.POORLY_DEFINED.getSNOMEDCTID(); break;
		}
	}
	/**
	 * Sets the value for ChestBorderDefinition
	 * @param enumChestBorderDefinition Object of EnumCM_ChestBorderDefinition.
	 */
	public void setChestBorderDefinition(EnumCM_ChestBorderDefinition enumChestBorderDefinition)
	{
		/**
		 * Retrieves the value for CodingSchemeDesignator, CodingSchemeVersion and Code Meaning and 
		 * sets the Code Value according to Code Meaning.
		 */
		this.strCodeMeaning = enumChestBorderDefinition.getValue();
		if(strCodeMeaning.equalsIgnoreCase(EnumCM_ChestBorderDefinition.WELL_DEFINED.getValue())
				|| strCodeMeaning.equalsIgnoreCase(EnumCM_ChestBorderDefinition.POORLY_DEFINED.getValue()))
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.SRT.getValue();
		else
			this.strCodingSchemeDesignator = EnumCodingSchemeDesignator.DCM.getValue();
		
		/**
		 * set code Value
		 */
		setCodeValue(enumChestBorderDefinition);

		/**
		 * set SNOMED-CT ID
		 */
		setSNOMEDCTID(enumChestBorderDefinition);
	}
}
